#!/usr/bin/perl

########################################################################################
#  File to collect License Information for all Licenses                                #                         #                                                                                      #
#  File is called by Gather.bat from the CC scheduler                                  #                             ########################################################################################

#####################################
#       Gather FlexLM Licenses      #
#####################################

$LIC_SERVER=CHANGE_TO_NAME_OF_LICENSE_SERVER;

sub GATHER{
    open (COMMAND, "cmd /c lmutil lmstat -f \"$LicType\" |");
    open (LICINFO, ">$LicCapture") || die "can't open";

        while (<COMMAND>) {
        print;
        print LICINFO;
        }

    close COMMAND;
    close LICINFO;

    open (LICINFO, "cmd /c find /C \"$LIC_SERVER\" $LicCapture |");
    open (LICCNT, ">$CountFile") || die "can't open";

        while (<LICINFO>) {
        print;
        print LICCNT;
        }

    close LICINFO;
    close LICCNT;

    open (LICINFO, "cmd /c find \"(Total of\"  $LicCapture |");
    open (MAX, ">$MaxNo") || die "can't open";

        while (<LICINFO>) {
        print;
        print MAX;
        }

    close LICINFO;
    close MAX;
    }

$Analyst=GATHER($LicType="AnalystStudio",
                $LicCapture="bobs\\anal.lic",
                $CountFile="bobs\\anal.cnt",
                $MaxNo="bobs\\anal.max");

$Test=GATHER($LicType="TestStudio",
             $LicCapture="bobs\\tststud.lic",
             $CountFile="bobs\\tststud.cnt",
             $MaxNo="bobs\\tststud.max");

$Quest=GATHER($LicType="ClearQuest",
              $LicCapture="bobs\\cq.lic",
              $CountFile="bobs\\cq.cnt",
              $MaxNo="bobs\\cq.max");

$Suite=GATHER($LicType="RationalSuiteEnterprise",
              $LicCapture="bobs\\rse.lic",
              $CountFile="bobs\\rse.cnt",
              $MaxNo="bobs\\rse.max");

$Rose=GATHER($LicType="rose_enterprise_windows",
			 $LicCapture="bobs\\rose.lic",
			 $CountFile="bobs\\rose.cnt",
			 $MaxNo="bobs\\rose.max");

###################################################
#          Gather ClearCase and MultiSite         #
###################################################

sub GATHERCASE{
    open (CLEAR, "cmd /c clearlicense -product $LicType |");
    open (CLEARLIC, ">$LicFile") || die "can't open";

        while (<CLEAR>) {
        print;
        print CLEARLIC;
        }

    close CLEAR;
    close CLEARLIC;

    open (CLEARLIC, "cmd /c find \"Maximum active users\" $LicFile |");
    open (CLEARMAX, ">$Max") || die "can't open";

        while (<CLEARLIC>) {
        print;
        print CLEARMAX;
        }

    close CLEARLIC;
    close CLEARMAX;

    open (CLEARLIC, "cmd /c find \"Current active users:\" $LicFile |");
    open (CLEARCUR, ">$Current") || die "can't open";

        while (<CLEARLIC>) {
        print;
        print CLEARCUR;
        }

    close CLEARLIC;
    close CLEARCUR;

    open (CLEARLIC, "cmd /c find \"license requests denied.\" $LicFile |");
    open (CLEARDEN, ">$Denied") || die "can't open";

        while (<CLEARLIC>) {
        print;
        print CLEARDEN;
        }

    close CLEARLIC;
    close CLEARDEN;
    }

$ClearCase=GATHERCASE($LicType="ClearCase",
                      $LicFile="bobs\\cc.lic",
                      $Max="bobs\\ccmax.cnt",
                      $Current="bobs\\cccur.cnt",
                      $Denied="bobs\\ccdenied.cnt");

$MultiSite=GATHERCASE($LicType="MultiSite",
                      $LicFile="bobs\\ms.lic",
                      $Max="bobs\\msmax.cnt",
                      $Current="bobs\\mscur.cnt",
                      $Denied="bobs\\msdenied.cnt");

system ("ccperl C:/license_info/collect.pl");
